#include "shared/classicmode/classicfactory.h"
#include "game/classicgame.h"
#include "graphics/classicgraphicsmanager.h"
#include "tools/music.h"

#include "editor/classiceditor.h"

#include <SFML/Graphics/RenderWindow.hpp>

std::unique_ptr<Game> classic::initGame(sf::RenderWindow& game_window)
{
    return std::make_unique<ClassicGame>(std::make_unique<ClassicGraphicsManager>(game_window));
}

std::unique_ptr<Editor> classic::initEditor(sf::RenderWindow& game_window)
{
    return std::make_unique<ClassicEditor>(std::make_unique<ClassicGraphicsManager>(game_window));
}
